/*
 * aufgabe1.c
 *
 *  Created on: 04.12.2012
 *      Author: Johann
 */
    
#include <stdio.h>
    

//   Funktionsdeklaration
double skalarprodukt(double *a, double *b);
void kreuzprodukt(double *a, double *b, double *erg);
double spatprodukt(double *a, double *b, double *c);
 

//   Hauptprogramm
int main(void) 
{
	setvbuf(stdout, NULL, _IONBF, 0);    /*Die Standard-Ausgabe wird nicht gepuffert*/

  double a[3], b[3], c[3];
  double erg[3];
  
  printf("Vektor a:\n a[0]= ");
  scanf("%lf", &a[0]);
  printf(" a[1]= ");
  scanf("%lf", &a[1]);
  printf(" a[2]= ");
  scanf("%lf", &a[2]);
   
  printf("Vektor b:\n b[0]= ");
  scanf("%lf", &b[0]);
  printf(" b[1]= ");
  scanf("%lf", &b[1]);
  printf(" b[2]= ");
  scanf("%lf", &b[2]);
  
  printf("Vektor c:\n c[0]= ");
  scanf("%lf", &c[0]);
  printf(" c[1]= ");
  scanf("%lf", &c[1]);
  printf(" c[2]= ");
  scanf("%lf", &c[2]);
   
  // Skalarprodukt
  printf(" <a, b> = %.2f\n", skalarprodukt(a, b));
   
  // Kreuzprodukt
  kreuzprodukt(a, b, erg);
  printf(" a x b = [ %.2f, %.2f, %.2f ]\n", erg[0], erg[1], erg[2]);
   
  // Spatprodukt
  printf("<(a x b), c>  = %f\n", spatprodukt(a, b, c));
  
  return 0;
}


//    Funktionsdefinition

    
//Skalarprodukt
double skalarprodukt(double *a, double *b) 
{
  return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
}

  
// Kreuzprodukt
void kreuzprodukt(double *a, double *b, double *erg) 
{
  erg[0] = a[1] * b[2] - a[2] * b[1];
  erg[1] = a[2] * b[0] - a[0] * b[2];
  erg[2] = a[0] * b[1] - a[1] * b[0];
  return;
}

 
//Spatprodukt
double spatprodukt(double *a, double *b, double *c) 
{
  double kprod[3];
  kreuzprodukt(a, b, kprod);
  return skalarprodukt(kprod, c);
}
 
